<template>
  <div class="row bg-primary entrypoint-chooser-wrapper">
    <div class="col-2">
      <q-select :options="nt_versions" v-model="local_nt_version" bg-color="white" label="NT Versie"
                class="q-px-md" outlined dense emit-value
                filled>
      </q-select>
    </div>
    <div class="col-9">
      <q-select :options="filtered_entrypoints" option-value="name" option-label="nice_name"
                v-model="local_dts_name" bg-color="white" label="Entrypoint"
                class="q-px-md" outlined use-input
                @filter="filterFn" dense
                filled>
        <template v-slot:no-option>
          <q-item>
            <q-item-section class="text-grey">
              No results
            </q-item-section>
          </q-item>
        </template>
      </q-select>
    </div>
    <div class="col-1">
      <q-btn label="Toon" :disable="!show_btn" color="red-8" @click="go_dts()"></q-btn>
    </div>
  </div>
</template>


<script>
import {ref} from 'vue'
import {api} from "boot/axios";
import SharedMethods from "components/SharedMethods";


export default {
  name: "EntrypointChooser",
  created() {
    this.set_nt_version = SharedMethods.set_nt_version
    this.get_nt_version = SharedMethods.get_nt_version
    this.fetchNTVersions()
  },
  computed: {
    show_btn() {
      return (this.local_nt_version > '' && this.local_dts_name.name > '')
    }
  },
  data() {
    return {
      nt_versions: undefined,
      entrypoints: undefined,
      filtered_entrypoints: undefined,
      local_nt_version: "",
      local_dts_name: {name: "", nice_name: ""},
    }
  },
  props: {
    current_nt_version: String,
    current_dts_name: String,
  },
  methods: {
    fetchNTVersions: function () {
      api
        .get("/nt-versions")
        .then(response => {
          this.nt_versions = response.data.nt_versions.filter(version => !version.value.toLowerCase().startsWith("agro"));
          ;
          if (this.current_nt_version && this.local_nt_version === "") {
            this.local_nt_version = this.current_nt_version
          }
        })
    },
    fetchEntrypoints: function () {
      if (this.local_nt_version)
        api
          .get("/dts", {params: {nt_version: this.local_nt_version}})
          .then(response => {
            this.entrypoints = response.data
            this.filtered_entrypoints = response.data
            if (this.current_dts_name && this.local_dts_name.name === "") {
              const current = this.entrypoints.filter(ep => {
                return ep.name === this.current_dts_name
              })
              if (current.length > 0) {
                this.local_dts_name = current[0].nice_name
              }
            }
          })
    },
    filterFn(val, update, abort) {
      update(() => {
        if (this.entrypoints) {
          const needle = val.toLowerCase()
          this.filtered_entrypoints = this.entrypoints.filter(v => v.nice_name.toLowerCase().indexOf(needle) > -1)
        }
      })
    },
    go_dts: function () {
      this.set_nt_version(this.local_nt_version)
      this.$router.push({path: "/dts/" + this.local_nt_version + "/" + this.local_dts_name.name})
    },
  },
  watch: {
    local_nt_version: function () {
      this.local_dts_name = ""
      this.fetchEntrypoints()
    }
  }
}
</script>

<style scoped lang="scss">
.entrypoint-chooser-wrapper {
}
</style>
